﻿'required imports

Imports System
Imports System.Drawing
Imports System.Windows.Forms
Imports GTA

Public Class carsale



    'public stuff, displaying stuff

    Inherits Script
    Private screenFont As New GTA.Font(0.15F, FontScaling.ScreenUnits)
    Private pixelFont As New GTA.Font(48, FontScaling.Pixel)

    Private screenBoxColor As Color = Color.FromArgb(0, 255, 0, 0)
    Private pixelBoxColor As Color = Color.FromArgb(0, 255, 0, 0)

    Public show As Boolean
    Public text As String
    Public misacc As Integer = 0

    'binding the mod to the phonenumber

    Public Sub New()
        BindPhoneNumber("carsell", AddressOf startcs)
        BindPhoneNumber("goons", AddressOf callgoons)
    End Sub

    'start mod, count how much vehicles sold, control missions

    Public Sub startcs()
        If (Player.WantedLevel > 0) Then
            text = "loose the cops first!"
            show = True
            Wait(5000)
            show = False
            Return
        End If
        If (carexport() = True) Then
            misacc += 1
            Game.DisplayText("Cars sold: " & misacc)
            If (Not (misacc = 0) And misacc Mod 5 = 0) Then
                If Not (misacc Mod 10 = 0) Then
                    text = "the cops want to talk to you about stolen cars!"
                    show = True
                    Player.WantedLevel = 1
                    Wait(5000)
                    show = False
                Else
                    text = "the cops are trying to bust you!"
                    show = True
                    Wait(5000)
                    show = False
                    Player.WantedLevel = 2
                End If
            End If
        Else
            'Game.Console.Print("Mission failed!")
        End If
    End Sub

    'required for displaying text at a given spot

    Public Sub Writer(ByVal sender As Object, ByVal e As GraphicsEventArgs) Handles MyBase.PerFrameDrawing
        Dim box As New RectangleF(300, 400, 1000, 128)
        If (show = True) Then
            e.Graphics.Scaling = FontScaling.Pixel
            e.Graphics.DrawRectangle(box, pixelBoxColor)
            e.Graphics.DrawText(text, box, TextAlignment.Center Or TextAlignment.VerticalCenter, Drawing.Color.White)
        End If
    End Sub

    'actual mod

    Public Function carexport() As Boolean
        'control variables

        Dim accomplished As Boolean = False
        Dim reward As Integer = 0

        'check if player is busy with a mission


        'show instruction


        Native.Function.Call("PLAY_AUDIO_EVENT", "MOBILE_PHONE_SMS_RECIEVE")
        text = "So you have a vehicle for us? Come to this position to deliver it!"
        show = True

        'declarations

        Dim PedPointer As New Native.Pointer(GetType(Ped))
        Dim vehpointer As New Native.Pointer(GetType(Vehicle))
        Dim PlayerChar As Ped = PedPointer
        Dim guy As Ped = PedPointer
        Dim pos As New Vector3
        Dim pcar As Vehicle = vehpointer
        Dim blob As Blip
        Dim chealth As Integer = 0

        'random number out of the game time

        Dim rand As New Random(System.DateTime.Now.Millisecond)
        rand.Next()

        'select random delivery spot

        Select Case (rand.Next(1, 5))
            Case 1
                pos = New Vector3(858.48F, -122.68F, 5.7F)
            Case 2
                pos = New Vector3(1390.04F, -267.51F, 19.69F)
            Case 3
                pos = New Vector3(1115.36F, 344.13F, 29.49F)
            Case 4
                pos = New Vector3(1851.79F, 703.13F, 25.74F)
            Case 5
                pos = New Vector3(1945.81F, 364.5F, 17.83F)
        End Select

        'add mission icon

        blob = GTA.Blip.AddBlip(pos)
        blob.Icon = BlipIcon.Misc_Deal
        blob.ShowOnlyWhenNear = False

        'create customer, make him proof to carjacking and wait for the player

        guy = World.CreatePed(897868981, pos)
        guy.BecomeMissionCharacter()
        guy.CanBeDraggedOutOfVehicle = False
        guy.CanBeKnockedOffBike = False
        guy.BlockPermanentEvents = True
        guy.Task.AlwaysKeepTask = True
        guy.Task.ClearAll()


        'give the player time to read the message

        Wait(5000)
        show = False

        'random encounter
        If ((rand.Next(1, 10)) Mod 5 = True) Then
            text = "You hurt somebodys business! Kill the attackers!"
            show = True
            callgoons()
            Wait(5000)
            show = False
        End If



        'wait until player is near delivery spot

        While Not (Player.Character.Position.DistanceTo2D(pos) < 3 Or Player.Character.isDead Or Player.WantedLevel > 0)
            Wait(1000)
        End While

        'delete marker

        blob.Delete()

        'check if player died or is wanted
        If (Player.Character.isDead) Then
            text = "you died!"
            reward = 0
            show = True
            Wait(5000)
            show = False
        End If
        If (Player.WantedLevel > 0) Then
            text = "loose the cops first!"
            reward = 0
            show = True
            Wait(5000)
            show = False
        End If
        'check if player has a vehicle

        If (Player.Character.isInVehicle = True And Player.Character.isDead = False And Player.WantedLevel = 0) Then
            'get vehicle + health

            pcar = Player.Character.CurrentVehicle
            chealth = Player.Character.CurrentVehicle.Health

            'Game.Console.Print(chealth)

            accomplished = True

            'check cars health decide if car is bought and for how much

            If (chealth > 950) Then
                text = "Thanks for the nice Ride here is some money for you: "
                reward = (showcarvalue() / 10)
                text = text & " " & reward & " $"
            ElseIf (chealth > 900) Then
                text = "there are some scratches, but okay i give you: "
                reward = (showcarvalue() / 14)
                text = text & " " & reward & " $"
            ElseIf (chealth > 800) Then
                text = "this dont looks to well, i give you: "
                reward = (showcarvalue() / 16)
                text = text & " " & reward & " $"
            ElseIf (chealth > 700) Then
                text = "I cant give you much for this: "
                reward = (showcarvalue() / 20)
                text = text & " " & reward & " $"
            Else
                accomplished = False
                text = "You better take this to a garage!"
                reward = 0
            End If
            show = True
            'throw character out, block player control until buyer is inside
            If (accomplished = True) Then
                guy.Weapons.Select(Weapon.Handgun_Glock)
                Player.Character.Task.LeaveVehicle()
                Player.CanControlCharacter = False
                Player.Character.Task.WanderAround()

                guy.Task.EnterVehicle(pcar, VehicleSeat.Driver)

                While Not (guy.isInVehicle = True)
                    Wait(1000)
                End While
                show = False

                Player.Character.Task.ClearAllImmediately()
                Player.CanControlCharacter = True

                'let buyer drive away, check if player attacks him
                Game.LoadAllPathNodes = True
                guy.Task.CruiseWithVehicle(pcar, 30, False)
                While Not (guy.Position.DistanceTo2D(Player.Character.Position) > 3 Or guy.HasBeenDamagedBy(Player))
                    Wait(1000)
                End While
                Player.Money += reward
                pcar.NoLongerNeeded()

                'fight back if buyer is attacked
                Dim contr As Boolean = False
                While (guy.Position.DistanceTo2D(Player.Character.Position) < 50 And contr = False)
                    If guy.HasBeenDamagedBy(Player) Then
                        accomplished = False
                        reward = 0
                        text = "Are you stupid or what? Guards, quick!"
                        show = True
                        guy.Task.FightAgainst(Player)
                        callgoons()
                        Wait(5000)
                        show = False
                        text = "you attacked the customer! deal failed"
                        contr = True
                    End If
                    Wait(2000)
                End While
            End If
            Wait(3000)
            show = False

            'weap.Delete()

        ElseIf (Player.WantedLevel = 0 And Player.Character.isAlive) Then

            'player delivered nothing
            text = "should i buy your ass? bring me a car!"
            accomplished = False
        Else
            accomplished = False
        End If
        'turn everything back to normal

        guy.CanBeDraggedOutOfVehicle = True
        guy.CanBeKnockedOffBike = True
        guy.BlockPermanentEvents = False
        guy.Task.AlwaysKeepTask = False
        guy.NoLongerNeeded()
        Game.LoadAllPathNodes = False
        If (accomplished = True) Then
            text = "deal finished!"
        Else
            text = "deal failed!"
        End If
        show = True
        Wait(5000)
        show = False
        'return mission success?
        Return accomplished
    End Function

    Private Sub callgoons()
        If (goonsarrive() = True) Then
            text = "you survived!"
        Else
            text = "you got killed!"
        End If
        show = True
        Wait(5000)
        show = False
    End Sub

    Private Function goonsarrive() As Boolean
        Dim PedModel As Model = "M_Y_BOUNCER_02"
        Dim PedPointer As New Native.Pointer(GetType(Ped))
        Dim vehpointer As New Native.Pointer(GetType(Vehicle))
        Dim pos As New Vector3
        Dim ppos As New Vector3
        ppos = Player.Character.Position
        Dim vehi As Vehicle = vehpointer
        pos = (GTA.World.GetPositionAround(ppos, 100))
        Dim guy As Ped = PedPointer
        Dim guy2 As Ped = PedPointer
        Dim blob1 As Blip
        Dim blob2 As Blip

        vehi = World.CreateVehicle("SENTINEL", World.GetNextPositionOnStreet(pos))
        vehi.PlaceOnNextStreetProperly()
        guy = vehi.CreatePedOnSeat(VehicleSeat.Driver, PedModel)
        PedModel = "M_Y_BOUNCER_01"
        guy2 = vehi.CreatePedOnSeat(VehicleSeat.AnyPassengerSeat, PedModel)
        blob1 = guy.AttachBlip()
        blob2 = guy2.AttachBlip()
        Dim group As New GTA.Group(guy)
        guy.RelationshipGroup = RelationshipGroup.Gang_AfricanAmerican
        group.AddMember(guy2, True)
        guy.Weapons.Glock.Ammo = 300
        guy.Weapons.Select(Weapon.Handgun_Glock)
        guy2.Weapons.Glock.Ammo = 300
        guy2.Weapons.Select(Weapon.Handgun_Glock)
        Game.LoadAllPathNodes = True

        guy.Task.AlwaysKeepTask = True
        guy.Task.ClearAll()
        guy.Enemy = True
        guy2.Enemy = True
        guy.Task.DriveTo(vehi, Player.Character.Position, 50, False)
        Dim iupd As Integer = 0
        While (vehi.Position.DistanceTo2D(Player.Character.Position) > 15)
            Wait(2000)
            iupd += 2
            If (iupd Mod 10 = 0) Then
                guy.Task.DriveTo(vehi, Player.Character.Position, 50, False)
            End If
        End While
        guy.Task.FightAgainst(Player)
        guy2.Task.FightAgainst(Player)
        Dim cupd As Integer = 0
        While (Player.Character.isAlive And (guy.isAlive Or guy2.isAlive))
            Wait(2000)
            cupd += 2
            If (guy.isDead) Then
                blob1.Delete()
            End If
            If (guy2.isDead) Then
                blob2.Delete()
            End If
            If ((cupd Mod 10) = 0) Then
                guy.Task.FightAgainst(Player)
                guy2.Task.FightAgainst(Player)
            End If
        End While
        blob1.Delete()
        blob2.Delete()
        guy.NoLongerNeeded()
        guy2.NoLongerNeeded()
        vehi.NoLongerNeeded()
        Game.LoadAllPathNodes = False
        If (Player.Character.isDead) Then
            Return False
        Else
            Return True
        End If
    End Function

    Private Function showcarvalue() As Integer
        Dim price As New Native.Pointer(GetType(Integer))
        Dim pint As Integer
        Dim cmodel As Model
        cmodel = Player.Character.CurrentVehicle.Model
        Native.Function.Call("GET_CAR_MODEL_VALUE", cmodel, price)
        pint = price.Value
        Return pint
    End Function
End Class
